package dev.shadowsoffire.apotheosis.garden;

import net.minecraft.world.level.Level;
import net.minecraftforge.common.ForgeHooks;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.util.RandomSource;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.world.level.block.CactusBlock;

public class ApothCactusBlock extends CactusBlock implements IReplacementBlock
{
    protected StateDefinition<Block, BlockState> container;
    
    public ApothCactusBlock() {
        super(BlockBehaviour.Properties.m_60926_((BlockBehaviour)Blocks.f_50128_));
    }
    
    public void m_213898_(final BlockState state, final ServerLevel world, final BlockPos pos, final RandomSource random) {
        final BlockPos blockpos = pos.m_7494_();
        if (!world.m_151570_(blockpos) && world.m_46859_(blockpos)) {
            int i = 1;
            if (GardenModule.maxCactusHeight <= 32) {
                while (world.m_8055_(pos.m_6625_(i)).m_60734_() == this) {
                    ++i;
                }
            }
            if (i < GardenModule.maxCactusHeight) {
                final int j = (int)state.m_61143_((Property)ApothCactusBlock.f_51131_);
                if (ForgeHooks.onCropsGrowPre((Level)world, blockpos, state, true)) {
                    if (j == 15) {
                        world.m_46597_(blockpos, this.m_49966_());
                        final BlockState newState = (BlockState)state.m_61124_((Property)ApothCactusBlock.f_51131_, (Comparable)0);
                        world.m_7731_(pos, newState, 4);
                        world.m_213960_(newState, blockpos, (Block)this, pos, false);
                    }
                    else {
                        world.m_7731_(pos, (BlockState)state.m_61124_((Property)ApothCactusBlock.f_51131_, (Comparable)(j + 1)), 4);
                    }
                    ForgeHooks.onCropsGrowPost((Level)world, pos, state);
                }
            }
        }
    }
    
    public void _setDefaultState(final BlockState state) {
        this.m_49959_(state);
    }
    
    public void setStateContainer(final StateDefinition<Block, BlockState> container) {
        this.container = container;
    }
    
    public StateDefinition<Block, BlockState> m_49965_() {
        return (StateDefinition<Block, BlockState>)((this.container == null) ? super.m_49965_() : this.container);
    }
}
